"""ControlWindow widgets"""

import BMenu
import BMenuBar
import BMenuItem
import BSeparatorItem
import BMessage
from AppKit import *
from InterfaceKit import *

from modules.config import Configuration
from modules.config import Accounts
from modules.constants import *
from constants import *
from modules.ui import *

### Menus
class MainMenu(BMenuBar.BMenuBar):
	"""The main menubar"""
	def __init__(self,bounds):
		BMenuBar.BMenuBar.__init__(self,(0,0,20,bounds[3]),'MainMenubar')
		self.AddItem(_HermodMenu())
		self.AddItem(_StatusMenu())

class _HermodMenu(BMenu.BMenu):
	"""The main menu"""
	def __init__(self):
		BMenu.BMenu.__init__(self, 'Hermod')
		self.AddItem(_AccountMenu())
		menuitems = [
			('Disconnect', MSG_DISCONNECT),
			('sep', ''),
			('Preferences', LAUNCH_PREFS),
			('About...', B_ABOUT_REQUESTED),
			('sep', ''),
			('Quit', B_QUIT_REQUESTED)
		]
		simpleMenu(self, menuitems)
		item = self.FindItem('Disconnect')
		item.SetEnabled(False)

class _StatusMenu(BMenu.BMenu):
	def __init__(self):
		BMenu.BMenu.__init__(self, 'Presence')
		conf = Configuration()
		stat = conf.options('presence', [])
		stat.sort()
		menuitems = []
		for i in stat:
			bmsg = BMessage.BMessage(OUTBOUND_PRESENCE)
			entry = conf.get('presence', i)
			values = entry.split(',')
			bmsg.AddString('show', values[1].strip())
			bmsg.AddString('status', values[0].strip())
			if len(values) > 2:
				bmsg.AddString('priority', values[2].strip())
			menuitems.append((values[0].strip(), bmsg))
		simpleMenu(self, menuitems)
		#self.SetTargetForItems(BApplication.be_app)
		self.SetEnabled(False)

class _AccountMenu(BMenu.BMenu):
	def __init__(self):
		BMenu.BMenu.__init__(self, 'Connect')
		menuitems = []
		accs = Accounts()
		acclist = accs.sections()
		for acc in acclist:
			bmsg = BMessage.BMessage(MSG_CONNECT)
			bmsg.AddString('account', acc)
			#item = BMenuItem.BMenuItem(accs.get(acc, 'name'),bmsg)
			#menuitems.append((accs.get(acc, 'name'), bmsg))
			menuitems.append((acc, bmsg))
		simpleMenu(self, menuitems)


