"""Canned replies and messages"""
import os
import time

import jabber.jabber as jabber

from modules.constants import *

# Iq's
class errorIq(jabber.Iq):
	def __init__(self, iq, errno, errstr):
		jabber.Iq.__init__(self, to=iq.getFrom(), type='error')
		self.setID(iq.getID())
		self.setError(errstr, errno)
		self.setFrom(iq.getTo())
	

class versionIq(jabber.Iq):
	def __init__(self, iq):
		jabber.Iq.__init__(self, to=iq.getFrom(), type='result')
		self.setID(iq.getID())
		self.setFrom(iq.getTo())
		qresult = self.setQuery(iq.getQuery())
		responses = {
			'name': 'Hermod',
			'version': '%s' % VERSION,
			'os': '%s %s (%s)' % (os.uname()[0], os.uname()[2], os.uname()[4])
		}
		for response in responses.keys():
			resp_node = qresult.insertTag(response)
			if responses[response]:
				resp_node.putData(responses[response])


class timeIq(jabber.Iq):
	def __init__(self, iq):
		jabber.Iq.__init__(self, to=iq.getFrom(), type='result')
		self.setID(iq.getID())
		self.setFrom(iq.getTo())
		qresult = self.setQuery(iq.getQuery())
		(tzn, dsttz) = time.tzname
		responses = {
			'utc': '%s' % time.strftime('%H:%M:%S'),
			'tz': '%s' % tzn,
			'display': '%s' % time.asctime()
		}
		for response in responses.keys():
			resp_node = qresult.insertTag(response)
			if responses[response]:
				resp_node.putData(responses[response])

