""" Jabber Contact viewer"""
import time

import BApplication
import BNode
import BEntry
import BMessage
from AppKit import *

from modules.constants import *
import modules.ui
from window import ContactWindow
from modules.log import log

class MainApp(BApplication.BApplication):
	def __init__(self, sig):
		BApplication.BApplication.__init__(self, sig)
		self.refs = False
		self.SetPulseRate(1000)

	def Pulse(self):
		if self.CountWindows() < 1:
			self.PostMessage(B_QUIT_REQUESTED)

	def RefsReceived(self, msg):
		if msg.what == B_REFS_RECEIVED:
			self.refs = True
			ix = 0
			while True:
				try:
					ref = msg.FindRef("refs", ix)
				except BMessage.error, val:
					break
				else:
					bnode = BNode.BNode(ref)
					bnode.InitCheck()
					attrinfo = bnode.GetAttrInfo('BEOS:TYPE')
					ftype = bnode.ReadAttr('BEOS:TYPE',0,0,attrinfo[1]-1)
					if ftype == 'application/x-person':
						try:
							attrinfo = bnode.GetAttrInfo('Jabber:JID')
							jid = bnode.ReadAttr('Jabber:JID',0,0,attrinfo[1]-1)
						except BNode.error:
							jid = None
						if jid is not None:
							win = modules.ui.findWindowByJID(jid)
						else:
							win = None
						if win is not None:
							win.Activate()
						else:
							entry = BEntry.BEntry(ref)
							win = ContactWindow(entry)
							win.Show()
				ix += 1

	def MessageReceived(self, msg):
		if (msg.what == ROSTER_ITEM_REQUEST and msg.IsReply()):
			win = modules.ui.findWindowByJID(msg.FindString('jid'))
			win.PostMessage(msg)

# Main
def main():
	# Start the App	
	ThisApp = MainApp(SIG_JABBERCONTACT)
	try:
		ThisApp.Run()
	except:
		trace = traceback.extract_stack()[-2]
		msg = '%s() [%s:%i]' % (trace[FUNCNAME], os.path.split(trace[FILENAME])[-1], trace[LINENO])
		log(msg)
		modules.ui.ErrorBox(msg, True)
		try:
			# try to quit cleanly
			ThisApp.PostMessage(B_QUIT_REQUSTED)
		except:
			pass


# Do the Mario
if __name__ == '__main__':
	main()
