""" Main """

import time

import BApplication
import BMessage
import BMessenger
import BNode
import BNodeInfo
import BEntry
from AppKit import *

from modules.constants import *
from modules.log import log
#from messagewindow import MessageWindow
#from replywindow import ReplyWindow
#from newwindow import NewWindow

import window

# BeOS Application
class MainApp(BApplication.BApplication):
	def __init__(self, sig):
		BApplication.BApplication.__init__(self, sig)
		self.refs = False
		self.SetPulseRate(1000)

	def Pulse(self):
		if self.CountWindows() < 1:
			self.PostMessage(B_QUIT_REQUESTED)
			time.sleep(1)

	def RefsReceived(self, msg):
		if msg.what == B_REFS_RECEIVED:
			self.refs = True
			ix = 0
			while True:
				try:
					ref = msg.FindRef("refs", ix)
				except BMessage.error, val:
					break
				else:
					bnode = BNode.BNode(ref)
					bnode.InitCheck()
					attrinfo = bnode.GetAttrInfo('BEOS:TYPE')
					ftype = bnode.ReadAttr('BEOS:TYPE',0,0,attrinfo[1]-1)
					if ftype == 'text/x-jabbermsg':
						entry = BEntry.BEntry(ref)
						win = window.Window(entry=entry, mode='view')
						win.Show()
					elif ftype == 'application/x-person':
						try:
							attrinfo = bnode.GetAttrInfo('Jabber:JID')
							jid = bnode.ReadAttr('Jabber:JID',0,0,attrinfo[1]-1)
						except BNode.error:
							pass
						else:
							win = window.Window(jid=jid, mode='new')
							win.Show()
				ix += 1
			else:
				self.refs = False

	def ReadyToRun(self):
		if not self.refs:
			win = window.Window(mode='new')
			win.Show()
		
	def MessageReceived(self, msg):
		if msg.what == REPLY_TO_MESSAGE:
			win = window.Window(jid=msg.FindString('sender'), subject=msg.FindString('subject'), body=msg.FindString('body'), mode='reply')
			win.Show()
		elif msg.what == OUTBOUND_MESSAGE:
			messenger = BMessenger.BMessenger(SIG_HERMOD)
			messenger.SendMessage(msg)
		elif msg.what == B_SILENT_RELAUNCH:
			win = window.Window(mode='new')
			win.Show()
			
# Main
def main():
	# Start the App	
	ThisApp = MainApp(SIG_JABBERMESSAGE)
	try:
		ThisApp.Run()
	except:
		trace = traceback.extract_stack()[-2]
		msg = '%s() [%s:%i]' % (trace[FUNCNAME], os.path.split(trace[FILENAME])[-1], trace[LINENO])
		log(msg)
		modules.ui.ErrorBox(msg, True)
		try:
			# try to quit cleanly
			ThisApp.PostMessage(B_QUIT_REQUSTED)
		except:
			pass

# Do the Mario
if __name__ == '__main__':
	main()
