"""Preferences widgets"""
import BMessage
import BListView
import BScrollView
import BTextControl
import BMenuField
import BPopUpMenu
import BMenuItem
import BSlider
from InterfaceKit import *

from modules.constants import *
from constants import *
from modules.config import Configuration

from widgets import *
from PrefsBase import PrefsBox

###### Logging
class PresenceBox(PrefsBox):
	def __init__(self, rect):
		PrefsBox.__init__(self, rect, 'loggingbox')
		bounds = self.Bounds()
		self.savecontrols = None
		self.conf = Configuration()
		self.section = 'presence'
		self.SetLabel('Presence')
		lv = BListView.BListView((5,20,bounds[2]-5-B_V_SCROLL_BAR_WIDTH,150), 'prslist',B_FOLLOW_TOP_BOTTOM)
		sv = BScrollView.BScrollView('scroll1', lv, B_FOLLOW_TOP_BOTTOM, B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW,
			False, True, B_PLAIN_BORDER)
		self.AddChild(sv)
		frame = lv.Frame()
		tc = BTextControl.BTextControl((5,frame[3]+25,0,0),'status', 'Status',
			'',None, B_FOLLOW_BOTTOM, B_WILL_DRAW)
		tc.ResizeToPreferred()
		tc.SetEnabled(False)
		self.AddChild(tc)
		frame = tc.Frame()
		pop = BPopUpMenu.BPopUpMenu('Crap')
		mf = BMenuField.BMenuField((5,frame[3]+5,bounds[2]-5,0),'show','Type',pop,B_FOLLOW_BOTTOM,B_WILL_DRAW)
		self.AddChild(mf)
		for show in ['chat','normal','away','xa','dnd']:
			pop.AddItem(BMenuItem.BMenuItem(show,BMessage.BMessage(CONTROL_EVENT)))
		pop.ResizeToPreferred()
		fh = pop.GetFontHeight()
		y = frame[1] + fh[0] + fh[1] + 40
		slider = BSlider.BSlider((5,y,bounds[2]-5,0),'priority','Priority',BMessage.BMessage(MSG_DUMMY),-5,40,B_BLOCK_THUMB,B_FOLLOW_BOTTOM)
		self.AddChild(slider)
		slider.SetHashMarks(B_HASH_MARKS_BOTTOM)
		slider.SetHashMarkCount(10)


