"""ControlWindow widgets"""

import BMenu
import BMenuBar
import BMenuItem
import BSeparatorItem
import BMessage
from AppKit import *
from InterfaceKit import *

from modules.config import Accounts
from modules.constants import *
from constants import *
from modules.ui import *

### Menus
class MainMenu(BMenuBar.BMenuBar):
	"""The main menubar"""
	def __init__(self,bounds):
		BMenuBar.BMenuBar.__init__(self,(0,0,20,bounds[3]),'MainMenubar')
		self.AddItem(_MainMenu())
		self.AddItem(_ContactsMenu())

class _MainMenu(BMenu.BMenu):
	"""The main menu"""
	def __init__(self):
		BMenu.BMenu.__init__(self, 'Program')
		self.AddItem(_AccountMenu())
		menuitems = [
			('sep', ''),
			('Quit', B_QUIT_REQUESTED)
		]
		simpleMenu(self, menuitems)

class _ContactsMenu(BMenu.BMenu):
	def __init__(self):
		BMenu.BMenu.__init__(self, 'Contacts')
		menuitems = [
			('Export', RM_EXPORT_CONTACTS),
			('Merge', RM_MERGE_CONTACT),
		]
		simpleMenu(self, menuitems)
		item = self.FindItem('Export')
		item.SetEnabled(False)
		item = self.FindItem('Merge')
		item.SetEnabled(False)

class _AccountMenu(BMenu.BMenu):
	def __init__(self):
		BMenu.BMenu.__init__(self, 'Get Roster')
		menuitems = []
		accs = Accounts()
		acclist = accs.sections()
		for acc in acclist:
			bmsg = BMessage.BMessage(RM_GET_ROSTER)
			bmsg.AddString('account', acc)
			menuitems.append((acc, bmsg))
		simpleMenu(self, menuitems)

