""" Logging """

import modules.config

SYSLOGIDENT='Hermod'

_config = modules.config.Configuration()
_logtype = _config.get('logging', 'type', 'stderr')
if _logtype == 'syslog':
	import syslog
else:
	import sys

def log(msg):
	if _logtype == 'syslog':
		_logsyslog(msg)
	else:
		_logstderr(msg)

def _logsyslog(msg):
	syslog.openlog(SYSLOGIDENT)
	syslog.syslog(msg)
	#syslog.closelog()

def _logstderr(msg):
	sys.stderr.write('%s\n' % (msg))
	sys.stderr.flush()
